anim8 = require 'anim8'
HC = require 'hardoncollider'
function on_collide(dt, a, b) --I'm not sure if this is how I'm supposed to do it
	if a.type == 'body' then
		if b.type == 'solid' then
			if a.y + a.height > b.y then
				a.y_speed = 0
				a.y = b.y - a.height
			elseif a.y < b.y + b.height then
				ay.y_speed = 0
				a.y = b.y + b.height
			end
			if  a.x + a.width > b.y then
				a.x_speed = 0
				a.x = b.x - a.width
			elseif a.x < b.x + b.width then
				a.x_speed = 0
				a.x = b.x
			end
		end
	end
	if b.type == 'body' then
		if a.type == 'solid' then
			if b.y + b.height > a.y then
				b.y_speed = 0
				b.y = a.y - b.height
			elseif b.y < a.y + a.height then
				b.y_speed = 0
				b.y = a.y + a.height
			end
			if  b.x + a.width > b.y then
				b.x_speed = 0
				b.x = a.x - b.width
			elseif b.x < a.x + a.width then
				b.x_speed = 0
				b.x = b.x
			end
		end
	end
end

function love.load()
	HC = HC.new(150)
	player = {}
	player.image = love.graphics.newImage('Stick fig with gun.png')
	bullet = love.graphics.newImage('bullet.png')
	bullet_anim8 = anim8.newGrid(5, 3, 5, 3)
	player.width = 19 
	player.height = 30
	player_anim8 = anim8.newGrid(player.width, player.height, player.image:getWidth(), player.image:getHeight())
	player.animation = anim8.newAnimation('loop', player_anim8('1-2,1'), 1)
	player.x = 300
	player.y = 250
	player.offset = 0 --so that the drawing will be in the right place but the x and y positions don't change
	player.x_speed = 0
	player.y_speed = 0
	player.gunHeight = 9
	player.direction = 1
	--player.gravity = 20 --Uncomment this line to turn on gravity
	player.HC = HC:addRectangle(player.x, player.y, player.width, player.height)
	player.type = 'body'
	shots = {}
	bullet_speed = 500
	bullet_freq = .5
	bullet_t = 0
	function shoot(direction)
		local shot = {}
		shot.x = player.x - player.width/2 + direction*player.width/2
		shot.y = player.y + player.gunHeight
		shot.dir = direction
		shot.animation = anim8.newAnimation('loop', bullet_anim8('1,1'), 0.1)
		shot.HC = HC:addRectangle(shot.x, shot.y, 3, 5)
		table.insert(shots, shot)
	end
	bg = {}
	bg.color = {255, 255, 255}
	love.graphics.setBackgroundColor(bg.color)
	ground = {}
	ground.height = 480
	ground.color = {0, 0, 0}
	ground.type = 'solid'
	HC:addRectangle(0,ground.height, 800, 600-ground.height)
end
function love.update(dt)
	if love.keyboard.isDown("left") and player.x > 0 then --I should probably turn all the player suff into a new file
		player.x_speed = 100
		player.direction = -1
		player.offset = 0
	end
	if love.keyboard.isDown("right") and player.x < (800-32) then
		player.x_speed = 100
		player.direction = 1
		player.offset = -player.width
	end
	if not(love.keyboard.isDown('right') or love.keyboard.isDown('left')) then
		player.x_speed = 0
	end
	player.x = player.x + player.x_speed*player.direction*dt
	--player.y_speed = player.y_speed + player.gravity*dt --Also needs to be uncommented to use gravity the next statment will work without it though
	player.y = player.y + player.y_speed*dt
	player.HC:moveTo(player.x + (player.width/2), player.y + (player.height/2))
	if love.keyboard.isDown(" ") and bullet_t > bullet_freq then
		shoot(player.direction)
		bullet_t = 0
	elseif bullet_t<=bullet_freq then
		bullet_t = bullet_t + dt
	end
	if love.keyboard.isDown("escape") then
		love.event.quit()
	end
	for i,v in ipairs(shots) do
		v.x = v.x + v.dir*bullet_speed*dt
		v.HC:move(v.x, v.y)
		if v.x > 800 or v.x < 0 then
			table.remove(shots, i)
		end
	end
	HC:update(dt)
	player.animation:update(dt)
end
function love.draw()
	love.graphics.setColor(ground.color)
	love.graphics.rectangle('fill', 0, ground.height, 800, 600-ground.height)
	player.animation:draw(player.image, player.x + player.offset, player.y, 0, player.direction, 1)
	for i,v in ipairs(shots) do
		v.animation:draw(bullet, v.x, v.y, 0, v.dir, 1)
	end
end